VERSION 5.00
Begin VB.Form frmMain 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Copy in background thread"
   ClientHeight    =   3795
   ClientLeft      =   45
   ClientTop       =   375
   ClientWidth     =   4095
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3795
   ScaleWidth      =   4095
   StartUpPosition =   3  'Windows Default
   Begin VB.Timer tmrRefresh 
      Enabled         =   0   'False
      Interval        =   100
      Left            =   3540
      Top             =   2640
   End
   Begin VB.CommandButton cmdPause 
      Caption         =   "Pause"
      Enabled         =   0   'False
      Height          =   435
      Left            =   2040
      TabIndex        =   10
      Top             =   3240
      Width           =   1395
   End
   Begin VB.Frame fraProgress 
      Caption         =   "Progress"
      Height          =   1635
      Left            =   120
      TabIndex        =   7
      Top             =   1500
      Width           =   3855
      Begin VB.PictureBox picProgress 
         BackColor       =   &H00C0FFC0&
         BorderStyle     =   0  'None
         Height          =   255
         Left            =   120
         ScaleHeight     =   255
         ScaleWidth      =   3615
         TabIndex        =   8
         Top             =   300
         Width           =   3615
      End
      Begin VB.Label lblCurrentFile 
         ForeColor       =   &H0000C000&
         Height          =   255
         Left            =   120
         TabIndex        =   11
         Top             =   1320
         Width           =   3615
      End
      Begin VB.Label lblInfo 
         Caption         =   "None"
         ForeColor       =   &H000000FF&
         Height          =   675
         Left            =   120
         TabIndex        =   9
         Top             =   600
         Width           =   3615
      End
   End
   Begin VB.CommandButton cmdCopy 
      Caption         =   "Copy"
      Height          =   435
      Left            =   540
      TabIndex        =   6
      Top             =   3240
      Width           =   1395
   End
   Begin VB.CommandButton cmdDestinationBrowse 
      Caption         =   "Browse..."
      Height          =   375
      Left            =   2700
      TabIndex        =   5
      Top             =   1020
      Width           =   1275
   End
   Begin VB.TextBox txtDestination 
      Height          =   375
      Left            =   120
      TabIndex        =   4
      Top             =   1020
      Width           =   2595
   End
   Begin VB.CommandButton cmdSourceBrowse 
      Caption         =   "Browse..."
      Height          =   375
      Left            =   2700
      TabIndex        =   2
      Top             =   360
      Width           =   1275
   End
   Begin VB.TextBox txtSource 
      Height          =   375
      Left            =   120
      TabIndex        =   1
      Top             =   360
      Width           =   2595
   End
   Begin VB.Label Label2 
      Caption         =   "Destination folder:"
      Height          =   255
      Left            =   120
      TabIndex        =   3
      Top             =   780
      Width           =   3795
   End
   Begin VB.Label Label1 
      Caption         =   "Source folder:"
      Height          =   255
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   3795
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Implements ICopyFolderNotify

Private Const BIF_RETURNONLYFSDIRS    As Long = &H1&
Private Const BIF_NEWDIALOGSTYLE      As Long = &H40&

Private hThread As Long
Private bCancel As Long
Private active  As Boolean
Private paused  As Boolean

Private Sub cmdCopy_Click()

    If active Then
        
        bCancel = True

    Else
    
        bCancel = False
        tmrRefresh.Enabled = True
        
        hThread = CopyFolderInNewThread(txtSource.Text, txtDestination.Text, Me, bCancel)
        
        If Not InIDE() Then

            If hThread = 0 Then
            
                tmrRefresh.Enabled = False
                MsgBox "Error", vbExclamation
                Exit Sub
                
            End If

        End If

    End If
    
End Sub

Private Sub cmdPause_Click()

    If paused Then
        cmdPause.Caption = "Pause"
        ResumeThread hThread
    Else
        cmdPause.Caption = "Resume"
        SuspendThread hThread
    End If
    
    paused = Not paused
    
End Sub

Private Sub cmdSourceBrowse_Click()
    Dim Path As String
    
    Path = BrowseForFolder()
    
    If Len(Path) Then
        txtSource.Text = Path
    End If
    
End Sub

Private Sub cmdDestinationBrowse_Click()
    Dim Path As String
    
    Path = BrowseForFolder()
    
    If Len(Path) Then
        txtDestination.Text = Path
    End If
    
End Sub

Private Function BrowseForFolder() As String
    Dim Folder As Object
    
    With CreateObject("Shell.Application")
        Set Folder = .BrowseForFolder(Me.hWnd, "Pick a folder", BIF_RETURNONLYFSDIRS Or BIF_NEWDIALOGSTYLE)
    End With
    
    If Not Folder Is Nothing Then
        BrowseForFolder = Folder.Self.Path
    End If
    
End Function

Private Sub Form_Unload(Cancel As Integer)
    
    If active Then
        MsgBox "You should stop copying before exit", vbInformation
        Cancel = True
    End If
    
End Sub

Private Sub ICopyFolderNotify_Cancel()
    MsgBox "Operation has been canceled", vbInformation
End Sub

Private Sub ICopyFolderNotify_Complete()

    lblCurrentFile = "Complete"
    lblInfo.Caption = "None"
  
    cmdCopy.Caption = "Copy"
    
    cmdPause.Enabled = False
    tmrRefresh.Enabled = False
    
    active = False
    bCancel = False
    
    picProgress.Cls
    
    CloseHandle hThread
    hThread = 0
    
    MsgBox "Operation completed", vbInformation

End Sub

Private Sub ICopyFolderNotify_CopyingStarts()
            
    lblInfo.Caption = "Getting information..."

    cmdCopy.Caption = "Cancel"
    
    If Not InIDE Then cmdPause.Enabled = True
    tmrRefresh.Enabled = True

    active = True
    
End Sub

Private Sub ICopyFolderNotify_CopyProgress( _
            ByVal TotalSize As Currency, _
            ByVal NumberOfBytesTransfered As Currency, _
            ByVal RemainData As Currency, _
            ByVal TotalBytesCount As Currency)
    Dim allProgress As Double
    Dim curProgress As Double
    
    If TotalBytesCount > 0 Then
        allProgress = RemainData / TotalBytesCount
    Else
        allProgress = 1
    End If
    
    If TotalSize > 0 Then
        curProgress = NumberOfBytesTransfered / TotalSize
    Else
        curProgress = 1
    End If
    
    picProgress.Cls
    
    If allProgress > curProgress Then
        picProgress.Line (0, 0)-(curProgress * picProgress.ScaleWidth, picProgress.ScaleHeight), RGB(0, 90, 0), BF
        picProgress.Line (curProgress * picProgress.ScaleWidth, 0)- _
                         (allProgress * picProgress.ScaleWidth, picProgress.ScaleHeight), RGB(0, 180, 0), BF
    Else
        picProgress.Line (0, 0)-(allProgress * picProgress.ScaleWidth, picProgress.ScaleHeight), RGB(0, 90, 0), BF
        picProgress.Line (allProgress * picProgress.ScaleWidth, 0)- _
                         (curProgress * picProgress.ScaleWidth, picProgress.ScaleHeight), RGB(0, 180, 0), BF
    End If
    
End Sub

Private Sub ICopyFolderNotify_EnumerationComplete( _
            ByVal NumberOfFiles As Currency, _
            ByVal NumberOfFolders As Currency, _
            ByVal TotalSizeData As Currency)
    UpdateInfo NumberOfFiles, NumberOfFolders, TotalSizeData
End Sub

Private Sub ICopyFolderNotify_EnumerationFailed()
    MsgBox "Enumeration failed", vbInformation
End Sub

Private Sub ICopyFolderNotify_ErrorOccurs(ByVal fileName As String, ByVal Reason As ErrorNumbers, WhatDo As VbMsgBoxResult)
    Dim strErr As String
    
    Select Case Reason
    Case ErrorNumbers.EN_UNABLE_TO_COPY_FILE
        strErr = "Unable to copy file"
    Case ErrorNumbers.EN_UNABLE_TO_CREATE_DIRECTORY
        strErr = "Unable to create directory"
    End Select
    
    WhatDo = MsgBox(strErr & vbNewLine & fileName, vbAbortRetryIgnore)
    
End Sub

Private Sub ICopyFolderNotify_NewFileStart( _
            ByVal fileName As String, _
            ByVal RemainFiles As Currency, _
            ByVal RemainFolders As Currency, _
            ByVal RemainDataCount As Currency)
    lblCurrentFile.Caption = fileName
    UpdateInfo RemainFiles, RemainFolders, RemainDataCount
End Sub

Private Sub ICopyFolderNotify_NewFolderStart( _
            ByVal folderName As String, _
            ByVal RemainFiles As Currency, _
            ByVal RemainFolders As Currency, _
            ByVal RemainDataCount As Currency)
    lblCurrentFile.Caption = folderName
    UpdateInfo RemainFiles, RemainFolders, RemainDataCount
End Sub

Private Sub UpdateInfo( _
            ByVal NumberOfFiles As Currency, _
            ByVal NumberOfFolders As Currency, _
            ByVal DataCountInBytes As Currency)
    lblInfo.Caption = "Remaining files: " & str(NumberOfFiles * 10000) & vbNewLine & _
                      "Remaining folders: " & str(NumberOfFolders * 10000) & vbNewLine & _
                      "Remaining bytes: " & str(DataCountInBytes * 10000)
End Sub

Private Sub tmrRefresh_Timer()
    SleepEx 0, 1
End Sub
